﻿using System.Collections.Generic;
using System.Windows.Forms;
using Infragistics.Win;
using Infragistics.Win.UltraWinGrid;

namespace ResizeBindInfragisticsGrid
{
    public class MyGridCreationFilter : IUIElementCreationFilter
    {
        Dictionary<UltraGridColumn, Control> relatedControls;

        internal MyGridCreationFilter(Dictionary<UltraGridColumn, Control> relatedControls)
        {
            this.relatedControls = relatedControls;
        }

        void IUIElementCreationFilter.AfterCreateChildElements(UIElement parent)
        {
            // What for HeaderUIElement.
            if (parent is HeaderUIElement)
            {
                // Get the associated column.
                UltraGridColumn column = parent.GetContext(typeof(UltraGridColumn)) as UltraGridColumn;
                if (column != null)
                {
                    // Get the associated control for that column.
                    Control control;
                    bool success = this.relatedControls.TryGetValue(column, out control);
                    if (success)
                    {
                        // Align the control Left and Width to the header UIElement
                        control.SetBounds(
                            parent.Rect.X,
                            control.Bounds.Y,
                            parent.Rect.Width,
                            control.Bounds.Height);
                    }
                }
            }
        }

        bool IUIElementCreationFilter.BeforeCreateChildElements(UIElement parent)
        {
            // Do nothing.
            return false;
        }
    }
}
